from axelrod.action import Action
from axelrod.player import Player
IIlIllllllIIIIIllIIl, IIIIIlllIIIlIII = Action.C, Action.D
class IIlIllIlllIlIlIlll(Player):
    lIlIlllIlIlIIlIlI = "strategy"
    IlllIIllIll = {
        "memory_depth": float("inf"),  
        "stochastic": False,
        "long_run_time": False,
        "inspects_source": False,
        "manipulates_source": False,
        "manipulates_state": False,
    }
    def __init__(IIlIIlIllIIlIllIIlIl, lIIlIllllII: int = 1, lIIlllllllllll: int = 4, lIllIIIlIlIlIII: int = 2) -> None:
        super().__init__()
        IIlIIlIllIIlIllIIlIl.lIIlIllllII = lIIlIllllII
        IIlIIlIllIIlIllIIlIl.lIIlllllllllll = lIIlllllllllll
        IIlIIlIllIIlIllIIlIl.lIllIIIlIlIlIII = lIllIIIlIlIlIII
        IIlIIlIllIIlIllIIlIl.IllIllIllIlI = [IIIIIlllIIIlIII] * (lIIlllllllllll - 1) + [IIlIllllllIIIIIllIIl] * lIllIIIlIlIlIII
        IIlIIlIllIIlIllIIlIl.llllIIIlllIIlll = False
        IIlIIlIllIIlIllIIlIl.llIllIlIllIIlllIllIl = 0
    def IlIIllIlllIllIlIll(IIlIIlIllIIlIllIIlIl, llllIIIllIlllllll: Player) -> Action:
        if IIlIIlIllIIlIllIIlIl.llllIIIlllIIlll:
            IlIIllIlllIllIlIll = IIlIIlIllIIlIllIIlIl.IllIllIllIlI[IIlIIlIllIIlIllIIlIl.llIllIlIllIIlllIllIl]
            IIlIIlIllIIlIllIIlIl.llIllIlIllIIlllIllIl += 1
            if IIlIIlIllIIlIllIIlIl.llIllIlIllIIlllIllIl == len(IIlIIlIllIIlIllIIlIl.IllIllIllIlI):
                IIlIIlIllIIlIllIIlIl.llllIIIlllIIlll = False
                IIlIIlIllIIlIllIIlIl.llIllIlIllIIlllIllIl = 0
            return IlIIllIlllIllIlIll
        elif [IIIIIlllIIIlIII] * IIlIIlIllIIlIllIIlIl.lIIlIllllII == llllIIIllIlllllll.history[-IIlIIlIllIIlIllIIlIl.lIIlIllllII :]:
            IIlIIlIllIIlIllIIlIl.llllIIIlllIIlll = True
            return IIIIIlllIIIlIII
        return IIlIllllllIIIIIllIIl
    def IlIIlIlIIlIIllllII(IIlIIlIllIIlIllIIlIl) -> str:
        return "%s: n=%s,d=%s,c=%s" % (IIlIIlIllIIlIllIIlIl.lIlIlllIlIlIIlIlI, IIlIIlIllIIlIllIIlIl.lIIlIllllII, IIlIIlIllIIlIllIIlIl.lIIlllllllllll, IIlIIlIllIIlIllIIlIl.lIllIIIlIlIlIII)